function [distance_mat, W, W_0] = Fisher_LDA(samp, datasets_cell, varargin)
%FISHER_LDA ͼڲͬľ
% 
% 룺ͼ񡢴ȽϵԭʼԪ
% ѡԤõͶӰWÿһΪһĬΪ
%       ԤõNx1ֽߴСNĬΪ
%       ǷΪMNISTݼboolѡĬΪfalseûݼ
% 
% һΪͬFisherбƱ
%       ƱֵΪԤ
%       ڶΪÿдһ
%       Ϊֽ룬ÿһжʹõ


% ÿѡ
ip = inputParser;
addOptional(ip, 'W', [], @isfloat); %ǷԤͶӰW
addOptional(ip, 'W_0', [], @isfloat); %÷ж
addOptional(ip, 'isMNIST', false, @islogical); %ǷʹMNISTݼ
parse(ip, varargin{:});
% ȡĬϲ
re_W = ip.Results.W; %ͶӰW
re_W_0 = ip.Results.W_0; %
isMNSIT = ip.Results.isMNIST; %־ǷʹMNISTݼ

if ~isMNSIT %ʹûݼ
    samp = reshape(samp, 1, []); %ͼչƽ
    mean_datasets = cellfun(@(x) get_datasets_mean(x), datasets_cell, ...
        'UniformOutput', false); %ȡѵֵ
    class_mean = cell2mat(mean_datasets);
    class_num = class_mean(:, 1); %ȡ
    class_n = length(class_num); %ȡ
    
    if isempty(re_W) || isempty(re_W_0) %Ҫ¼ͶӰ
        sel_mat = -1 .* ones(class_n * (class_n - 1) / 2, class_n);%ĬϾ
        rows = 1; %ѭѡĵǰ
        for i = 1:class_n - 1
            for j = i + 1:class_n
               sel_mat(rows, i) = 1; %ѡ
               sel_mat(rows, j) = 0; %ѡ
               rows = rows + 1;
            end
        end
        sel_cell = mat2cell(sel_mat, ones(1, rows - 1));%ѡcell
        W_cell = cellfun(@(x) get_mat_W(datasets_cell, x), sel_cell, ...
            'UniformOutput', false);
        W_mat = cell2mat(W_cell);
        W = W_mat(:, 2:end)'; %ͶӰ
        W_0 = W_mat(:, 1)'; %ֵ
    else %Ҫ¼ͶӰֱֵʹֵ
        W = re_W; %ʹWΪͶӰ
        W_0 = re_W_0; %ʹķֵ
    end
    
    distance = samp * W + W_0; %µľ
    % One vs OneͶҪ޸ֵ
    output_distance = zeros(1, class_n); %Ҫվ
    for i = 1:class_n - 1
        sum_distance = sum(distance((2 * class_n - i) * (i - 1) / 2 + 1: ...
            (2 * class_n - i - 1) * i / 2) > 0); %
        for j = 2:i - 1 %ɢĸ
            sum_distance = sum_distance + ...
                (distance((2 * class_n - j) * (j - 1) / 2 + i - j) < 0);
        end
        output_distance(i) = sum_distance; %浽
        output_distance(class_n) = output_distance(class_n) + ...
            (distance((2 * class_n - i - 1) * i / 2) < 0); %һƱ
    end
    distance_mat = output_distance ./ (class_n - 1); %ͶƱ
else
    disp_c('MNISTݼعδ');
    [distance_mat, W, W_0] = deal([], [], []); %󷵻ؿ
end
% 
end



% ѵݼָľֵ͸
function result_cell = get_datasets_mean(datasets_mat)
mean_result = mean(datasets_mat, 1);
num = size(datasets_mat, 1);
result_cell = [num, mean_result];
end

% ͶӰWĺ
function mat_row = get_mat_W(datasets_cell, sel_row)
pos_sets = cell2mat(datasets_cell(sel_row == 1)); %
neg_sets = cell2mat(datasets_cell(sel_row == 0)); %
[m, n] = deal(size(pos_sets, 1), size(neg_sets, 1)); %
pos_mean = mean(pos_sets, 1); %ֵ
neg_mean = mean(neg_sets, 1); %ֵ
pos_cell = mat2cell(pos_sets, ones(1, size(pos_sets, 1))); %cell
neg_cell = mat2cell(neg_sets, ones(1, size(neg_sets, 1))); %cell
S1_cell = cellfun(@(x) (x - pos_mean)' * (x - pos_mean), pos_cell, ...
    'UniformOutput', false);
S2_cell = cellfun(@(x) (x - neg_mean)' * (x - neg_mean), neg_cell, ...
    'UniformOutput', false);
% *** ԪcatΪ3άصά *** %
S1 = sum(cat(3, S1_cell{:}), 3); %ɢȾ
S2 = sum(cat(3, S2_cell{:}), 3); %ɢȾ
Sw = S1 + S2; %ɢȾ
W_ = pinv(Sw) * (pos_mean - neg_mean)'; %ͶӰW*Ϊȶʹα
W_0 = -0.5 * ((pos_mean + neg_mean) * W_) - log(n / m); %µķֵ
% W_0 = - (pos_mean * W_ + neg_mean * W_) ./ 2; %ƽֵ
mat_row = [W_0, W_']; %
end