function fin_result = algorithm_test(index, shape, rate, varargin)
%ALGORITHM_TEST ͬ㷨ͨòԺͨѡ㷨
% 
% Input
%   indexint֣ʾҪ֤㷨
%          1ʾڽģƥ䷨(Nearly Model)
%          2ʾСʵıҶ˹(Lowest Error Bayes Classifier)
% 
%   shapeintͻfloat֣ʾͼƬĴС
% 
%   ratefloat֣ʾеĲ
% 
%   (ѡ)flushboolͱʾǷҪˢûݼ
% 
% Output
%   fin_resultNx2float飬NʾȡĲԼͼƬһбʾ
%               㷨Ԥ𣬵ڶбʾжʹõָꡣ
%   ע쳣ؿ

% ÿѡ
p = inputParser;
addOptional(p, 'flush', false, @islogical);
addOptional(p, 'data_dir', '..\data\', @ischar);
parse(p, varargin{:});
flush = p.Results.flush; %Ƿˢûݼ־
data_dir = p.Results.data_dir; %ݼļ

test_path = strcat(data_dir, 'user_test\');
algorithm_result = []; %ĬϽ
% 㷨б
algorithm_str = {'ڽģƥ䷨'; 'СʵıҶ˹'; ...
    'Fisherб'};
test_cell = get_test_datasets(shape, rate, false, test_path);%ȡݼ
test_size = length(test_cell{1, 1}); %ȡĲԼ
if ~isempty(test_cell) %ȡݼɹ
    datasets_cell = get_user_datasets(shape, rate, flush, data_dir);
    if ~isempty(datasets_cell) %ûݼȡɹ
        tic; %ʼʱ
        algorithm_result = compare_program(index, test_cell, datasets_cell);
        if ~isempty(algorithm_result)
            accuracy_mat = mean(algorithm_result{1}, 1); %ƽ׼ȷ
            accuracy = accuracy_mat(1); %ڽƽ׼ȷ
            class_acc = algorithm_result{2}; %µ׼ȷ
        else
            accuracy = NaN; %д
            class_acc = NaN;
        end
        time = toc; %мʱ
        % н
        str_ = strcat('ȡ', num2str(test_size), 'ŲͼƬ', ...
            '֤', algorithm_str{index, 1}, 'ɣʱ', ...
            num2str(time, 3), '룬ƽ׼ȷΪ', num2str(accuracy(1), 3));
        disp_c(str_);
        str_ = strcat('0-9ʮ׼ȷʷֱΪ', num2str(class_acc, 3));
        disp_c(str_);
    else
        disp_c('ȡûݼʧܣݼַļ');
    end
else
    disp_c('ȡԼʧܣݼַݼ');
end
fin_result = algorithm_result; %
end

%-------------------------------------------------------------------------%
% 㷨н
function [result_cell] = compare_program(index, test_cell, datasets_cell)
class_num = test_cell{1, 1}; %õ飬ʽΪNx1
picture_mat = test_cell{1, 2}; %õͼƬ飬ʽΪNx(shape*shape)
datasets = datasets_cell(1: 10); %ųûݼеĿհ
% лͼƬΪԪ
pic_cell = mat2cell(picture_mat, ones(1, size(picture_mat, 1)));

% ѡӦ㷨м
switch index
    case 1 %ʹڽģƥ䷨õÿݵķ͸
        compare_cell = cellfun(@(x) nearly_model(x, datasets), pic_cell, ...
            'UniformOutput', false);
    case 2 %ʹСʵıҶ˹õÿݵķ͸
        compare_cell = cellfun(@(x) lowest_error_bayes(x, datasets), ...
            pic_cell, 'UniformOutput', false);
    case 3 %ʹFisherбõÿݵķ͸
        [~, W, W_0] = Fisher_LDA(pic_cell{1}, datasets_cell); %ԤWW_0
        compare_cell = cellfun(@(x) compare_Fisher_LDA(x, datasets_cell, ...
            W, W_0, false), pic_cell, 'UniformOutput', false);
    otherwise
        disp_c('δɻʹ쳣indexֵ');
        compare_cell = {}; %쳣ؿԪ
end

% 㷨׼ȷ
if ~isempty(compare_cell)
    compare_mat = cell2mat(compare_cell); %ԪתΪ
    % ׼ȷ
    result = compare_mat(:, 2) == class_num; %õ㷨ԤĽ
    result_mat = [result, compare_mat(:, 1)]; %ԤԼԤʷ
    % ׼ȷ
    class_name = 0:9; %
    multi_acc_mat = arrayfun(@(x) multi_acc(x, compare_mat, class_num), ...
        class_name);
    result_cell = {result_mat; multi_acc_mat};
else
    result_cell = {}; %㷨쳣ؿ
end
end


%-------------------------------------------------------------------------%
% ͬľµƽ׼ȷ
function class_accuracy = multi_acc(class, pred_mat, samp_class)
class_index = samp_class == class; %õǰ
result_acc = pred_mat(class_index, 2) == class;
class_accuracy = mean(result_acc);
end

%-------------------------------------------------------------------------%
% 뵥ͼƬõСʺԤ
function result_mat = lowest_error_bayes(samp_pic, datasets_cell)
class_prob = posterior_prob(samp_pic, datasets_cell); %
[acc, class] = max(class_prob); %ҵֵ
result_mat = [1 - acc / sum(class_prob, 1), class - 1]; %شʺ
end

%-------------------------------------------------------------------------%
% 뵥ͼƬFisherԷԤŶȺԤ
function result_mat = compare_Fisher_LDA(x, dataset_cell, W, W_0, isMNIST)
distance = Fisher_LDA(x, dataset_cell, W, W_0, isMNIST); %Fisher
rate = exp(distance) / sum(exp(distance)); %Softmax
[acc, class] = max(rate); %ȡֵӦ
result_mat = [acc, class - 1]; %ŶȺ
end