function output_cell = get_MNIST_datasets(varargin)
%GET_MNIST_DATASETS ͨصreadMNISTȡ
% λ ..\data\MNIST\ ļµMNISTݼתΪ
% Ԫ
% 
% ע⣺MNISTݼΪ20x20xNСNΪ
% ȥΧı߿򣬶ӦıǩΪNx1Сѵ
% Ϊtrain_cell60000ݺͱǩԼΪ
% test_cell10000ݺͱǩ
% 
% עѵ/cell·Ϊtrain_mattrain_lab
% ע߼ֵ()1ɫ߼ֵ()0ɫ

% ÿѡ
ip = inputParser;
validDir = @(x) ischar(x);
%Ĭݼ·
addOptional(ip, 'dir', '..\data\', validDir); %Ĭļ·
parse(ip, varargin{:});
% ȡĬϲ
data_dir = ip.Results.dir; %ԼͼƬļ·

disp_c('ʼȡMNISTݼ......');
tic; %ʱ
cache_path = strcat(data_dir, 'cache_data\');
file_path = strcat(cache_path, 'MNIST.mat');
if exist(cache_path, 'dir')
    if exist(file_path, 'file')
        try
            train = load(file_path, 'train_cell');
            test = load(file_path, 'test_cell');
            train_cell = train.train_cell;
            test_cell = test.test_cell;
        catch
            disp_c('ȡMNISTݴ󣬳Դԭʼݼ¶ȡ');
            [train_cell, test_cell] = get_MNIST_test_datasets(data_dir);
            save(file_path, 'train_cell', 'test_cell');
            output_cell = {train_cell; test_cell};
            end_t = toc; %óʱ
            disp_c('Ȼ󣬵Ǵԭʼݼȡɹ');
            str_ = strcat('кʱ', num2str(end_t, 3), '');
            disp_c(str_);
            return; %ǰ˳
        end
    else
        [train_cell, test_cell] = get_MNIST_test_datasets();
    end
else
    mkdir(cache_path);
    [train_cell, test_cell] = get_MNIST_test_datasets();
end
% 沢ȡ
save(file_path, 'train_cell', 'test_cell');
output_cell = {train_cell; test_cell};
disp_c('ȡMNISTݼɹ');
end_t = toc; %óʱ
str_ = strcat('кʱ', num2str(end_t, 3), '');
disp_c(str_);
end


% ȡѵ
function [train_cell, test_cell] = get_MNIST_test_datasets(path)
imgFile = strcat(path, 'MNIST\train-images-idx3-ubyte');
labelFile = strcat(path, 'MNIST\train-labels-idx1-ubyte');
[train_img, train_lab] = readMNIST(imgFile, labelFile, 60000, 0);
% ȡԼ
imgFile = strcat(path, 'MNIST\t10k-images-idx3-ubyte');
labelFile = strcat(path, 'MNIST\t10k-labels-idx1-ubyte');
[test_img, test_lab] = readMNIST(imgFile, labelFile, 10000, 0);
% imshow(MNIST_train_datasets(:, :, 3));
% imshow(MNIST_train_datasets(:, :, 5000));
% Զȡͼжֵתɫ
train_thresh = graythresh(train_img);
test_thresh = graythresh(test_img);
train_mat = (train_img < train_thresh);
test_mat = (test_img < test_thresh);
train_cell = {train_mat; train_lab};
test_cell = {test_mat; test_lab};
% Զȡݽоת
% MNIST_train_mat = permute(train_datasets, [3, 1, 2]);
% MNIST_test_mat = permute(test_datasets, [3, 1, 2]);
end

