function datasets_cell = get_user_datasets(samp_shape, samp_rate, varargin)
%GET_USER_DATASETS ȡݼͼƬתΪcell鷵ظ

% ÿѡ
ip = inputParser;
%Ĭݼ·
addOptional(ip, 'flush', false, @islogical); %Ƿˢݼļб
addOptional(ip, 'dir', '..\data\', @ischar); %Ĭdataļ·
parse(ip, varargin{:});
% ȡĬϲ
flush = ip.Results.flush; %־Ƿˢݼб
data_dir = ip.Results.dir; %dataļ·

time_flag = false; %жǷʱ
dir = strcat(data_dir, 'user_datasets\'); %dataµݼļ·
if ~exist(dir, 'dir')
    disp_c('ݼַȷļУ');
    disp(dir);
    datasets_cell = {}; %󷵻ؿյԪ
    return; %˳
end
cache_dir = strcat(data_dir, 'cache_data\'); %建ļ
% ݼɵԪ黺ļ·
data_path_mat_path = strcat(cache_dir, 'data_path.mat');
tic; %ʱ
% ȡݼбɵԪ
if ~exist(cache_dir, 'dir')
    time_flag = true; %־ʼʱ
    mkdir(cache_dir); %ڻļ򴴽
    data_path = list_file('root_dir', dir); %ͼƬַɵԪ
    save(data_path_mat_path, 'data_path');
elseif flush || ~exist(data_path_mat_path, 'file') %Ҫˢ»򻺴ļ
    time_flag = true; %־ʼʱ
    data_path = list_file('root_dir', dir); %ͼƬַɵԪ
    save(data_path_mat_path, 'data_path');
else
    try
        ld_struct = load(data_path_mat_path, 'data_path');
        data_path = ld_struct.data_path;
    catch %ȡԤ洢ļҲֱӴûݼȡ
        %ʹĬϵַͼƬַɵԪ
        time_flag = true; %־ʼʱ
        data_path = list_file('root_dir', dir);
        save(data_path_mat_path, 'data_path');
    end
end

% ݻȡݼļɵԪȡͼƬ
file_name = sprintf('data_%d_%.3f.mat', samp_shape, samp_rate);
data_name = strcat(cache_dir, file_name);
if isempty(data_path)
   disp_c('ûлȡݼκͼƬ');
   disp_c('ע⣺ֵ֧jpgbmppngʽͼƬ');
   datasets_cell = {}; %δȡκͼƬؿ
elseif ~flush && exist(data_name, 'file')
    ld_struct = load(data_name, 'datasets_cell');
    datasets_cell = ld_struct.datasets_cell;
else
    class = length(data_path);
%     disp(['ȡݼ', num2str(class), '']);
    datasets_cell = cellfun( ...
        @(x) load_picture(x, samp_shape, samp_rate), ...
        data_path, 'UniformOutput', false);
%     disp(['ȡͼƬĳߴΪ', mat2str(size(datasets_cell{3,1}))]);
    % ӿհͼƬ
    white_pic = ones(samp_shape, samp_shape);
    datasets_cell(class + 1) = {reshape(white_pic, ...
        [1, samp_shape * samp_shape])};
    save(data_name, 'datasets_cell');
end
if time_flag
   time = toc; %ͳƳˢûݼʱ
   str_ = strcat('½ûݼɣʱ', num2str(time, 3), '');
   disp_c(str_);
end
