function [list_path, test_class_num] = list_testsets_file(varargin)
%LIST_TESTSETS_FILE оٲݼļµͼƬ·
% 
% ѡ룺ȡԼݼļеַ
% 
% list_pathʾвԼͼ·ɵԪ飬
%       test_class_numʾͳƵ0-9ʮĸ

% ÿѡ
ip = inputParser;
validPath = @(x) exist(x, 'dir'); %жļǷ
%Ĭݼַ
addOptional(ip, 'root_dir', '..\data\user_test\', validPath);
parse(ip, varargin{:});
root_dir = ip.Results.root_dir;

% жļǷ,ȡļµĲͬ·
if exist(root_dir, 'dir')
    jpg_path = dir(strcat(root_dir, '*-*.jpg'));
    png_path = dir(strcat(root_dir, '*-*.png'));
    bmp_path = dir(strcat(root_dir, '*-*.bmp'));
    file_path = [jpg_path; png_path; bmp_path]; %ϻȡָʽļĽ
    list_path = arrayfun(@(x) strcat(x.folder, '\', x.name), file_path, ...
        'UniformOutput', false); %ȡļ·ļ
    class_str = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};%ǩ
    test_class_num = cellfun(@(x) get_test_class_num(x, file_path), ...
        class_str); %ȡԼÿ
else
    disp_c('ݼַڣ ..\data\user_test\ ļǷ');
    list_path = {}; %бַΪԪ
end
% 
end


% ȡԼض
function class_num = get_test_class_num(class_str, path_struct)
class_num = sum(arrayfun(@(x) x.name(1) == class_str, path_struct));
end