function result_cell = get_test_datasets(varargin)
%GET_TEST_DATASETS ȡ㷨ʹõĲݼͼƬ
% ѡĸǰsamp_shapesamp_rateֱʾС
% ͲʣisMNISTжҪȡݼǷΪMNISTݼĸdir
% ʾҪȡݼĵַ
% 
% ע⣺ͼƬӦ÷ͬһļ

% ÿѡ
ip = inputParser;
%Ĭݼ·
addOptional(ip, 'samp_shape', 5, @isfloat); %òС
addOptional(ip, 'samp_rate', 0.1, @isfloat); %ò
addOptional(ip, 'isMNIST', false, @islogical); %ǷʹMNISTݼ
addOptional(ip, 'dir', '..\data\user_test\', @ischar); %Ĭļ·
parse(ip, varargin{:});
% ȡĬϲ
shape = fix(ip.Results.samp_shape); %ͼС
rate = ip.Results.samp_rate; %ͼ
isMNIST = ip.Results.isMNIST; %־ǷʹMNISTݼ
data_dir = ip.Results.dir; %ԼͼƬļ·

if isMNIST %ʹMNISTݼ
    disp_c('δɣڴ');
    result_cell = {}; %ĬϿԪ
else %ʹûݼ
    if ~exist(data_dir, 'dir')
        disp_c('ݼַȷļУ');
        disp(data_dir);
        result_cell = {}; %󷵻ؿյԪ
    else
        tic; %ʼȡļʱ
        %˻ļ·
        cache_dir = strcat(data_dir, 'cache\');
        file_name = sprintf('test_%d_%.3f.mat', shape, rate);
        mat_name = strcat(cache_dir, file_name);
        if ~exist(cache_dir, 'dir')
            mkdir(cache_dir)
        end
        if exist(mat_name, 'file')
           try
               result_cell = load(mat_name); %ȡĲ
               result_cell = result_cell.result_cell; %ȡṹе
           catch
               result_cell = {}; %ȡļ󷵻ؿԪ
               disp_c('ȡѻĲԼļɾļ');
               str_ = strcat('ļĿ¼', cache_dir);
               disp_c(str_);
           end
        else
            file_str = dir(data_dir); %õݼļ
            if length(file_str) < 4 %ļΪ
                result_cell = {};
            else
                class = arrayfun(@(x) str2double(x.name(1)), ...
                    file_str(3: end));  %ȡԼ𣬷double
                samp = arrayfun(@(x) load_samp(x.name, data_dir, ...
                    shape, rate), file_str(3: end), ...
                    'UniformOutput', false); %ȡͼƬݲչƽ
                class(isnan(class)) = []; %ɾǲԼͼƬļNaN
                result_cell = {class,cell2mat(samp)};
                save(mat_name, 'result_cell'); %ļ
                time = toc; %ȡݼʱ
                str_ = strcat('½Լݳɹʱ', ...
                    num2str(time, 3), '');
                disp_c(str_);
            end
        end
    end
end
% 
end



% ļ͵ַȡͼƬĲСͲʲȡͼƬ
function return_mat = load_samp(name, data_dir, shape, rate)
try
    picture = imread(strcat(data_dir, name)); %ȡͼƬ
    samp = sample(picture, shape, rate); %ͼƬ
    return_mat = reshape(samp, 1, []); %ͼƬչƽ󷵻
catch
    return_mat = []; %󷵻ؿ
end
% 
end