function [output] = sample(picture, varargin)
%SAMPLE ȡͼ񲢽õͷֱͼ

% ÿѡ
ip = inputParser;
validShape = @(x) isnumeric(x) && isscalar(x) && (x >= 5 && x <= 50);
validRate = @(x) isnumeric(x) && isscalar(x) && (x > 0 && x <= 2);
addOptional(ip, 'shape', 5, validShape); %ĬĿͼߴΪ5x5
addOptional(ip, 'rate', 0.1, validRate); %òʱʹõֵ
% addOptional(ip, 'linewidth', 3.5); %Ĭ߿Ϊ3.5
parse(ip, varargin{:});
% ȡĬϲ
shape = ip.Results.shape;
rate = ip.Results.rate;
% linewidth = ip.Results.linewidth;

aspect_ratio = 1.2; %Ʋͼĳ
% ͼжֵ
samp = im2bw(picture);
[samp_m, samp_n] = size(samp); %ԭʼͼĳͿ
% ȡͼѡɾͼΧĿհ
find_cols = find(sum(1 - samp) > 0);
find_rows = find(sum(1 - samp, 2) > 0);
if isempty(find_cols) || isempty(find_rows)
    find_cols = [1, samp_n];
    find_rows = [1, samp_m];
end
[xmin, xmax] = deal(find_cols(1), find_cols(end));
[ymin, ymax] = deal(find_rows(1), find_rows(end));
% disp([xmin, xmax, ymin, ymax]);
% ƻõѡ򳤿
[width, height] = deal((xmax - xmin + 1), (ymax - ymin + 1));%ȡѡĳߴ
if width / height > aspect_ratio
    res = fix((width - height) / 2); %Ҫİ
    [ymin, ymax] = deal(ymin - res, ymax + res); %߽
    if ymin < 1
        ymax = ymax - 1 + ymin; %ʹͼ
        ymin = 1; %Խ߽
    end
    if ymax > samp_m
        ymin = ymin - 1 + (ymax - samp_m); %ʹͼ
        ymax = samp_m; %Խ߽
    end
elseif height / width > aspect_ratio
    res = fix((height - width) / 2); %Ҫİ
    [xmin, xmax] = deal(xmin - res, xmax + res); %߽
    if xmin < 1
        xmax = xmax - 1 + xmin; %ʹͼ
        xmin = 1; %Խ߽
    end
    if xmax > samp_n
        xmin = xmin - 1 + (xmax - samp_n); %ʹͼ
        xmax = samp_n; %Խ߽
    end
end
samp = samp((ymin: ymax), (xmin: xmax)); %ȡкɫصĲ

samp = 1 - samp; %ɫת1ʾɫ0ʾɫ

% ɾհױ߿ͼнõͷֱͼ
if (xmax - xmin + 1) < shape || (ymax - ymin + 1) < shape
    output = imresize(samp, [shape, shape]); %ԭʼͼֱʹ
% elseif (shape > 28 && linewidth > 7.0)
%     % imresizeʵһ߿
%     output = imresize(samp, [shape, shape]); %ʵõķ
else
    [m, n] = size(samp); %ͼߴ
    % ȷֿĳߴ磬ȼÿֿ鳤Ϳ
    height_m = fix(m / shape);
    width_n = fix(n / shape);
    % 㵼µ
    res_m = m - height_m * shape;
    res_n = n - width_n * shape;
    % ѡȡķʽȷĳһĴС
    block_m = ones(1, shape) * height_m;
    block_n = ones(1, shape) * width_n;
    index_m = unidrnd(shape, 1, res_m);
    index_n = unidrnd(shape, 1, res_n);
    for index = index_m
        block_m(index) = block_m(index) + 1;
    end
    for index = index_n
        block_n(index) = block_n(index) + 1;
    end
    mc = mat2cell(samp, block_m, block_n);
    % ʹþֲֵȽ϶ȫ־ֵ
    output = cellfun(@(x) local_compare(x, rate), mc);
%     % ʹȫ־ֵȽ
%     % ʹcellfunԪԪִͺ
%     sum_mc = cellfun(@(x) sum(x(:)), mc); %ÿֿĺɫغ
%     mean_mc = mean(sum_mc(:));
%     % ʹarrayfunԪִк
%     output = arrayfun(@(x) compare(x, rate * mean_mc), sum_mc);
    
%     % ʹѭж
%     output = ones(shape, shape);
%     for i=1:shape
%         for j=1:shape
%             if(sum_mc(i, j) < rate * mean_mc)
%                 output(i, j) = 0;
%             end
%         end
%     end
end
% end
end


% % ȫ־ֵȽϺ
% function [out] = compare(x, y)
% if x < y
%     out = 0;
% else
%     out = 1;
% end
% end

% ֲֵȽϺ
function [out] = local_compare(x, rate)
whole_x = size(x, 1) * size(x, 2);
sum_x = sum(x(:));
if sum_x / whole_x >= rate
    out = 0;
else
    out = 1;
end
end
